Index: main/waeup.ikoba/trunk/src/waeup/ikoba/locales/waeup.ikoba.pot
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/locales/waeup.ikoba.pot	(revision 12553)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/locales/waeup.ikoba.pot	(revision 12554)
@@ -15,5 +15,5 @@
 msgstr ""
 "Project-Id-Version: Development/Unknown\n"
-"POT-Creation-Date: Mon Feb  2 08:48:41 2015\n"
+"POT-Creation-Date: Tue Feb  3 18:11:27 2015\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
@@ -121,5 +121,5 @@
 
 #: waeup/ikoba/browser/interfaces.py:173
-#: waeup/ikoba/customers/interfaces.py:200
+#: waeup/ikoba/customers/interfaces.py:201
 #: waeup/ikoba/interfaces.py:428
 #: waeup/ikoba/interfaces.py:504
@@ -1493,36 +1493,36 @@
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:101
-#: waeup/ikoba/customers/interfaces.py:195
-#: waeup/ikoba/customers/interfaces.py:213
+#: waeup/ikoba/customers/interfaces.py:102
+#: waeup/ikoba/customers/interfaces.py:196
+#: waeup/ikoba/customers/interfaces.py:214
 msgid "First Name"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:106
-#: waeup/ikoba/customers/interfaces.py:218
+#: waeup/ikoba/customers/interfaces.py:107
+#: waeup/ikoba/customers/interfaces.py:219
 msgid "Middle Name"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:111
-#: waeup/ikoba/customers/interfaces.py:223
+#: waeup/ikoba/customers/interfaces.py:112
+#: waeup/ikoba/customers/interfaces.py:224
 msgid "Last Name (Surname)"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:116
+#: waeup/ikoba/customers/interfaces.py:117
 msgid "Sex"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:122
-#: waeup/ikoba/customers/interfaces.py:161
-#: waeup/ikoba/customers/interfaces.py:190
+#: waeup/ikoba/customers/interfaces.py:123
+#: waeup/ikoba/customers/interfaces.py:162
+#: waeup/ikoba/customers/interfaces.py:191
 msgid "Registration Number"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:129
-#: waeup/ikoba/customers/interfaces.py:228
+#: waeup/ikoba/customers/interfaces.py:130
+#: waeup/ikoba/customers/interfaces.py:229
 msgid "Email"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:136
+#: waeup/ikoba/customers/interfaces.py:137
 #: waeup/ikoba/interfaces.py:433
 #: waeup/ikoba/interfaces.py:511
@@ -1530,46 +1530,46 @@
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:252
+#: waeup/ikoba/customers/interfaces.py:253
 #: waeup/ikoba/documents/interfaces.py:52
 msgid "Document Id"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:303
+#: waeup/ikoba/customers/interfaces.py:304
 msgid "Contract Id"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:309
-#: waeup/ikoba/customers/interfaces.py:332
+#: waeup/ikoba/customers/interfaces.py:310
+#: waeup/ikoba/customers/interfaces.py:333
 msgid "Product"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:315
-#: waeup/ikoba/customers/interfaces.py:365
+#: waeup/ikoba/customers/interfaces.py:316
+#: waeup/ikoba/customers/interfaces.py:366
 #: waeup/ikoba/products/interfaces.py:73
 msgid "Options/Fees"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:344
-#: waeup/ikoba/customers/interfaces.py:379
+#: waeup/ikoba/customers/interfaces.py:345
+#: waeup/ikoba/customers/interfaces.py:380
 msgid "Document"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:355
+#: waeup/ikoba/customers/interfaces.py:356
 msgid "Comment"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:82
+#: waeup/ikoba/customers/interfaces.py:83
 msgid "Account suspended"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:88
+#: waeup/ikoba/customers/interfaces.py:89
 msgid "Reasons for Deactivation"
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:90
+#: waeup/ikoba/customers/interfaces.py:91
 msgid "This message will be shown if and only if deactivated customers try to login."
 msgstr ""
 
-#: waeup/ikoba/customers/interfaces.py:96
+#: waeup/ikoba/customers/interfaces.py:97
 #: waeup/ikoba/customers/browser_templates/containerpage.pt:31
 msgid "Customer Id"
@@ -1761,165 +1761,165 @@
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:103
-#: waeup/ikoba/customers/workflow.py:124
-msgid "Reset to requested"
-msgstr ""
-
 #: waeup/ikoba/customers/workflow.py:104
 #: waeup/ikoba/customers/workflow.py:125
+msgid "Reset to requested"
+msgstr ""
+
+#: waeup/ikoba/customers/workflow.py:105
+#: waeup/ikoba/customers/workflow.py:126
 msgid "Reset to 'requested'"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:111
+#: waeup/ikoba/customers/workflow.py:112
+#: waeup/ikoba/customers/workflow.py:215
+#: waeup/ikoba/customers/workflow.py:216
+#: waeup/ikoba/customers/workflow.py:222
+#: waeup/ikoba/customers/workflow.py:223
+#: waeup/ikoba/customers/workflow.py:229
+#: waeup/ikoba/customers/workflow.py:230
+#: waeup/ikoba/customers/workflow.py:243
+#: waeup/ikoba/customers/workflow.py:244
+#: waeup/ikoba/customers/workflow.py:334
+#: waeup/ikoba/customers/workflow.py:335
+#: waeup/ikoba/customers/workflow.py:341
+#: waeup/ikoba/customers/workflow.py:342
+#: waeup/ikoba/customers/workflow.py:348
+#: waeup/ikoba/customers/workflow.py:349
+#: waeup/ikoba/customers/workflow.py:362
+#: waeup/ikoba/customers/workflow.py:363
+msgid "Reset to initial state"
+msgstr ""
+
+#: waeup/ikoba/customers/workflow.py:186
+msgid "Create contract"
+msgstr ""
+
+#: waeup/ikoba/customers/workflow.py:189
+msgid "Contract created"
+msgstr ""
+
+#: waeup/ikoba/customers/workflow.py:194
+msgid "Submit for approval"
+msgstr ""
+
+#: waeup/ikoba/customers/workflow.py:195
+msgid "Submitted for approval"
+msgstr ""
+
+#: waeup/ikoba/customers/workflow.py:201
+msgid "Approve"
+msgstr ""
+
+#: waeup/ikoba/customers/workflow.py:202
+msgid "Approved"
+msgstr ""
+
+#: waeup/ikoba/customers/workflow.py:208
+#: waeup/ikoba/customers/workflow.py:327
+msgid "Reject"
+msgstr ""
+
 #: waeup/ikoba/customers/workflow.py:209
-#: waeup/ikoba/customers/workflow.py:210
-#: waeup/ikoba/customers/workflow.py:216
-#: waeup/ikoba/customers/workflow.py:217
-#: waeup/ikoba/customers/workflow.py:223
-#: waeup/ikoba/customers/workflow.py:224
+#: waeup/ikoba/customers/workflow.py:328
+msgid "REJECTED"
+msgstr ""
+
+#: waeup/ikoba/customers/workflow.py:236
 #: waeup/ikoba/customers/workflow.py:237
-#: waeup/ikoba/customers/workflow.py:238
-#: waeup/ikoba/customers/workflow.py:324
-#: waeup/ikoba/customers/workflow.py:325
-#: waeup/ikoba/customers/workflow.py:331
-#: waeup/ikoba/customers/workflow.py:332
-#: waeup/ikoba/customers/workflow.py:338
-#: waeup/ikoba/customers/workflow.py:339
-#: waeup/ikoba/customers/workflow.py:352
-#: waeup/ikoba/customers/workflow.py:353
-msgid "Reset to initial state"
-msgstr ""
-
-#: waeup/ikoba/customers/workflow.py:180
-msgid "Create contract"
-msgstr ""
-
-#: waeup/ikoba/customers/workflow.py:183
-msgid "Contract created"
-msgstr ""
-
-#: waeup/ikoba/customers/workflow.py:188
-msgid "Submit for approval"
-msgstr ""
-
-#: waeup/ikoba/customers/workflow.py:189
-msgid "Submitted for approval"
-msgstr ""
-
-#: waeup/ikoba/customers/workflow.py:195
-msgid "Approve"
-msgstr ""
-
-#: waeup/ikoba/customers/workflow.py:196
-msgid "Approved"
-msgstr ""
-
-#: waeup/ikoba/customers/workflow.py:202
-#: waeup/ikoba/customers/workflow.py:317
-msgid "Reject"
-msgstr ""
-
-#: waeup/ikoba/customers/workflow.py:203
-#: waeup/ikoba/customers/workflow.py:318
-msgid "REJECTED"
-msgstr ""
-
-#: waeup/ikoba/customers/workflow.py:230
-#: waeup/ikoba/customers/workflow.py:231
-#: waeup/ikoba/customers/workflow.py:345
-#: waeup/ikoba/customers/workflow.py:346
+#: waeup/ikoba/customers/workflow.py:355
+#: waeup/ikoba/customers/workflow.py:356
 msgid "Set to expired"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:295
+#: waeup/ikoba/customers/workflow.py:305
 #: waeup/ikoba/documents/workflow.py:37
 msgid "Create document"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:298
+#: waeup/ikoba/customers/workflow.py:308
 #: waeup/ikoba/documents/workflow.py:40
 msgid "Document created"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:303
+#: waeup/ikoba/customers/workflow.py:313
 msgid "Submit for verification"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:304
+#: waeup/ikoba/customers/workflow.py:314
 msgid "Submitted for verification"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:310
+#: waeup/ikoba/customers/workflow.py:320
 msgid "Verify"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:311
+#: waeup/ikoba/customers/workflow.py:321
 msgid "Verified"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:45
+#: waeup/ikoba/customers/workflow.py:46
 msgid "Create customer"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:48
+#: waeup/ikoba/customers/workflow.py:49
 msgid "Customer created"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:53
+#: waeup/ikoba/customers/workflow.py:54
 msgid "Start registration"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:56
+#: waeup/ikoba/customers/workflow.py:57
 msgid "Customer registration started"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:61
+#: waeup/ikoba/customers/workflow.py:62
 msgid "Request registration"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:62
+#: waeup/ikoba/customers/workflow.py:63
 msgid "Customer registration requested"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:68
+#: waeup/ikoba/customers/workflow.py:69
 msgid "Approve customer provisionally"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:69
+#: waeup/ikoba/customers/workflow.py:70
 msgid "Customer registration provisionally approved"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:75
+#: waeup/ikoba/customers/workflow.py:76
 msgid "Approve finally"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:76
+#: waeup/ikoba/customers/workflow.py:77
 msgid "Customer registration finally approved"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:82
+#: waeup/ikoba/customers/workflow.py:83
 msgid "Approve customer"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:83
+#: waeup/ikoba/customers/workflow.py:84
 msgid "Customer registration approved"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:89
+#: waeup/ikoba/customers/workflow.py:90
 msgid "Reject customer"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:90
+#: waeup/ikoba/customers/workflow.py:91
 msgid "Customer registration rejected"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:96
-#: waeup/ikoba/customers/workflow.py:110
-#: waeup/ikoba/customers/workflow.py:117
+#: waeup/ikoba/customers/workflow.py:97
+#: waeup/ikoba/customers/workflow.py:111
+#: waeup/ikoba/customers/workflow.py:118
 msgid "Reset customer"
 msgstr ""
 
-#: waeup/ikoba/customers/workflow.py:97
-#: waeup/ikoba/customers/workflow.py:118
+#: waeup/ikoba/customers/workflow.py:98
+#: waeup/ikoba/customers/workflow.py:119
 msgid "Reset to initial customer state"
 msgstr ""
@@ -2183,4 +2183,8 @@
 
 #: waeup/ikoba/interfaces.py:614
+msgid "Notify customers by email"
+msgstr ""
+
+#: waeup/ikoba/interfaces.py:619
 msgid "Captcha used for public registration pages"
 msgstr ""
@@ -2823,5 +2827,5 @@
 
 #: waeup/ikoba/payments/currencies.py:77
-#: waeup/ikoba/payments/paypal_currencies.py:40
+#: waeup/ikoba/payments/paypal_currencies.py:41
 msgid "Euro"
 msgstr ""
@@ -3744,93 +3748,93 @@
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:34
+#: waeup/ikoba/payments/paypal_currencies.py:35
 msgid "Australian dollar"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:35
+#: waeup/ikoba/payments/paypal_currencies.py:36
 msgid "Brazilian real"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:36
+#: waeup/ikoba/payments/paypal_currencies.py:37
 msgid "Canadian dollar"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:37
+#: waeup/ikoba/payments/paypal_currencies.py:38
 msgid "Swiss franc"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:38
+#: waeup/ikoba/payments/paypal_currencies.py:39
 msgid "Czech koruna"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:39
+#: waeup/ikoba/payments/paypal_currencies.py:40
 msgid "Danish krone"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:41
+#: waeup/ikoba/payments/paypal_currencies.py:42
 msgid "Pound sterling"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:42
+#: waeup/ikoba/payments/paypal_currencies.py:43
 msgid "Hong Kong dollar"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:43
+#: waeup/ikoba/payments/paypal_currencies.py:44
 msgid "Hungarian forint"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:44
+#: waeup/ikoba/payments/paypal_currencies.py:45
 msgid "Israeli new shekel"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:45
+#: waeup/ikoba/payments/paypal_currencies.py:46
 msgid "Japanese yen"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:46
+#: waeup/ikoba/payments/paypal_currencies.py:47
 msgid "Mexican peso"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:47
+#: waeup/ikoba/payments/paypal_currencies.py:48
 msgid "Malaysian ringgit"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:48
+#: waeup/ikoba/payments/paypal_currencies.py:49
 msgid "Norwegian krone"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:49
+#: waeup/ikoba/payments/paypal_currencies.py:50
 msgid "New Zealand dollar"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:50
+#: waeup/ikoba/payments/paypal_currencies.py:51
 msgid "Philippine peso"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:51
-msgid "Polish zloty"
-msgstr ""
-
 #: waeup/ikoba/payments/paypal_currencies.py:52
+msgid "Polish z\305\202oty"
+msgstr ""
+
+#: waeup/ikoba/payments/paypal_currencies.py:53
 msgid "Swedish krona"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:53
+#: waeup/ikoba/payments/paypal_currencies.py:54
 msgid "Singapore dollar"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:54
+#: waeup/ikoba/payments/paypal_currencies.py:55
 msgid "Thai baht"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:55
+#: waeup/ikoba/payments/paypal_currencies.py:56
 msgid "Turkish lira"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:56
+#: waeup/ikoba/payments/paypal_currencies.py:57
 msgid "New Taiwan dollar"
 msgstr ""
 
-#: waeup/ikoba/payments/paypal_currencies.py:57
+#: waeup/ikoba/payments/paypal_currencies.py:58
 msgid "United States dollar"
 msgstr ""
@@ -4241,5 +4245,5 @@
 
 #: waeup/ikoba/utils/countries.py:169
-#: waeup/ikoba/utils/utils.py:51
+#: waeup/ikoba/utils/utils.py:52
 msgid "Nigeria"
 msgstr ""
@@ -4894,5 +4898,5 @@
 
 #: waeup/ikoba/utils/countries.py:90
-#: waeup/ikoba/utils/utils.py:50
+#: waeup/ikoba/utils/utils.py:51
 msgid "Germany"
 msgstr ""
@@ -4934,9 +4938,9 @@
 msgstr ""
 
-#: waeup/ikoba/utils/utils.py:110
+#: waeup/ikoba/utils/utils.py:111
 msgid "no contract"
 msgstr ""
 
-#: waeup/ikoba/utils/utils.py:155
+#: waeup/ikoba/utils/utils.py:156
 msgid ""
 "Fullname: ${a}\n"
@@ -4948,5 +4952,5 @@
 msgstr ""
 
-#: waeup/ikoba/utils/utils.py:207
+#: waeup/ikoba/utils/utils.py:208
 msgid ""
 "Dear ${a},\n"
@@ -4968,5 +4972,24 @@
 msgstr ""
 
-#: waeup/ikoba/utils/utils.py:52
+#: waeup/ikoba/utils/utils.py:256
+msgid ""
+"Dear ${a},\n"
+"\n"
+"The status of the following object has been changed:\n"
+"\n"
+"Object Id: ${c}\n"
+"Title: ${d}\n"
+"Transition: ${e}\n"
+"New state: ${f}\n"
+"\n"
+"Regards,\n"
+"\n"
+"${b}\n"
+"\n"
+"--\n"
+"${g}\n"
+msgstr ""
+
+#: waeup/ikoba/utils/utils.py:53
 msgid "U.S."
 msgstr ""