Index: /main/ikobacustom.pcn/trunk/src/ikobacustom/pcn/customers/interfaces.py
===================================================================
--- /main/ikobacustom.pcn/trunk/src/ikobacustom/pcn/customers/interfaces.py	(revision 12576)
+++ /main/ikobacustom.pcn/trunk/src/ikobacustom/pcn/customers/interfaces.py	(revision 12577)
@@ -313,93 +313,96 @@
         )
 
-    qualifications = schema.List(
+    qualifications = schema.Text(
         title = _(u'Qualifications'),
-        value_type = ResultEntryField(),
-        required = False,
+        description = u'Enter a list of certificates obtained.',
+        required = False,
+        readonly = False,
+        )
+
+    certificates_object = schema.Choice(
+        title = _(u'Certificates'),
+        description = u'Select the document which contains scanned copies '
+                      u'of your certificates. You must create such a '
+                      u'document first.',
+        source = CustomerDocumentSource(),
+        required = False,
+        )
+
+    referee1_name = schema.TextLine(
+        title = _(u'First Referee Name'),
+        required = False,
+        readonly = False,
+        )
+
+    referee1_address = schema.Text(
+        title = _(u'First Referee Address'),
+        required = False,
+        readonly = False,
+        )
+
+    referee1_license = schema.TextLine(
+        title = _(u'First Referee License Number'),
+        required = False,
+        readonly = False,
+        )
+
+    referee2_name = schema.TextLine(
+        title = _(u'Second Referee Name'),
+        required = False,
+        readonly = False,
+        )
+
+    referee2_address = schema.Text(
+        title = _(u'Second Referee Address'),
+        required = False,
+        readonly = False,
+        )
+
+    referee2_license = schema.TextLine(
+        title = _(u'Second Referee License Number'),
+        required = False,
+        readonly = False,
+        )
+
+    internship_address = schema.Text(
+        title = _(u'Internship'),
+        description = u'Enter name and address of company where you want to serve your internship.',
+        required = False,
+        readonly = False,
+        )
+
+
+
+class IRPRContractOfficialUse(IIkobaObject):
+    """Interface for editing RON official use data.
+
+    """
+
+    comment = schema.Text(
+        title= _('Reason for rejection'),
+        required = False,
+        )
+
+
+class IRPRContractProcess(IRPRContract, IRPRContractOfficialUse):
+    """Interface for processing RON data.
+    """
+
+    product_options = schema.List(
+        title = _(u'Options/Fees'),
+        value_type = ProductOptionField(),
+        required = False,
+        readonly = False,
         default = [],
         )
+
+class IRPRContractEdit(IRPRContract):
+    """Interface for editing RON data by customers.
+
+    """
 
     certificates = schema.Choice(
         title = _(u'Certificates'),
         source = CustomerDocumentSource(),
-        required = False,
-        )
-
-    referee1_name = schema.TextLine(
-        title = _(u'First Referee Name'),
-        required = False,
-        readonly = False,
-        )
-
-    referee1_address = schema.Text(
-        title = _(u'First Referee Address'),
-        required = False,
-        readonly = False,
-        )
-
-    referee1_license = schema.TextLine(
-        title = _(u'First Referee License Number'),
-        required = False,
-        readonly = False,
-        )
-
-    referee2_name = schema.TextLine(
-        title = _(u'Second Referee Name'),
-        required = False,
-        readonly = False,
-        )
-
-    referee2_address = schema.Text(
-        title = _(u'Second Referee Address'),
-        required = False,
-        readonly = False,
-        )
-
-    referee2_license = schema.TextLine(
-        title = _(u'Second Referee License Number'),
-        required = False,
-        readonly = False,
-        )
-
-    internship_address = schema.Text(
-        title = _(u'Internship'),
-        description = u'Enter address of company where you want to serve your internship.',
-        required = False,
-        readonly = False,
-        )
-
-
-
-class IRPRContractOfficialUse(IIkobaObject):
-    """Interface for editing RON official use data.
-
-    """
-
-    comment = schema.Text(
-        title= _('Reason for rejection'),
-        required = False,
-        )
-
-
-class IRPRContractProcess(IRPRContract, IRPRContractOfficialUse):
-    """Interface for processing RON data.
-    """
-
-    product_options = schema.List(
-        title = _(u'Options/Fees'),
-        value_type = ProductOptionField(),
-        required = False,
-        readonly = False,
-        default = [],
-        )
-
-class IRPRContractEdit(IRPRContract):
-    """Interface for editing RON data by customers.
-
-    """
-
-    certificates = schema.Choice(
-        title = _(u'Certificates'),
-        source = CustomerDocumentSource(),
-        required = True,
-        )
+        required = True,
+        )