Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/sample_contract_data.csv
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/sample_contract_data.csv	(revision 12553)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/sample_contract_data.csv	(revision 12580)
@@ -1,8 +1,8 @@
-class_name,contract_id,reg_number,product_object,document_object,product_options,tc_dict
-SampleContract,c3,1,SAM,DOC1,"[('Base Fee', '800.6', 'USD')]",{'en':'Hello World'}
-SampleContract,c4,2,SAM,DOC1,[],{}
-SampleContract,c5,3,SAM,DOC1,[],{}
-SampleContract,,1,SAM,DOC1,[],{}
-SampleContract,c5,2,SAM,DOC1,[],{}
-SampleContract,c6,3,SAM,NONEXISTENT,[],{}
-SampleContract,c7,3,NONEXISTENT,DOC1,[],{}
+class_name,contract_id,reg_number,product_object,document_object,product_options,tc_dict,title
+SampleContract,c3,1,SAM,DOC1,"[('Base Fee', '800.6', 'USD')]",{'en':'Hello World'},Nice Contract
+SampleContract,c4,2,SAM,DOC1,[],{},
+SampleContract,c5,3,SAM,DOC1,[],{},
+SampleContract,,1,SAM,DOC1,[],{},
+SampleContract,c5,2,SAM,DOC1,[],{},
+SampleContract,c6,3,SAM,NONEXISTENT,[],{},
+SampleContract,c7,3,NONEXISTENT,DOC1,[],{},
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_batching.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_batching.py	(revision 12553)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_batching.py	(revision 12580)
@@ -498,8 +498,8 @@
         fail_file = open(fail_file).read()
         self.assertEqual(fail_file,
-            'reg_number,contract_id,class_name,product_object,tc_dict,document_object,product_options,--ERRORS--\r\n'
-            '2,c5,SampleContract,SAM,{},DOC1,[],This object already exists. Skipping.\r\n'
-            '3,c6,SampleContract,SAM,{},NONEXISTENT,[],document_object: Invalid value\r\n'
-            '3,c7,SampleContract,NONEXISTENT,{},DOC1,[],product_object: Invalid value\r\n'
+            'reg_number,contract_id,title,class_name,product_object,tc_dict,document_object,product_options,--ERRORS--\r\n'
+            '2,c5,,SampleContract,SAM,{},DOC1,[],This object already exists. Skipping.\r\n'
+            '3,c6,,SampleContract,SAM,{},NONEXISTENT,[],document_object: Invalid value\r\n'
+            '3,c7,,SampleContract,NONEXISTENT,{},DOC1,[],product_object: Invalid value\r\n'
             )
         contract = self.processor.getEntry(dict(reg_number='1',
@@ -523,5 +523,5 @@
         self.assertTrue(
             'INFO - system - Customer Sample Contract Processor - sample_contract_data - '
-            'X666666 - %s - updated: product_object=SAM, tc_dict={}, document_object=DOC1, '
+            'X666666 - %s - updated: title=, product_object=SAM, tc_dict={}, document_object=DOC1, '
             'product_options=[]' % conid
             in logcontent)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py	(revision 12553)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_browser.py	(revision 12580)
@@ -1440,4 +1440,5 @@
         self.contract.product_object = self.product
         self.contract.tc_dict = {'en': u'<strong>Hello world</strong>'}
+        self.contract.title = u'Contract Title'
         self.browser.open(self.customer_path + '/contracts/CON1')
         self.browser.getLink("Download contract slip").click()
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_export.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_export.py	(revision 12553)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/tests/test_export.py	(revision 12580)
@@ -278,5 +278,5 @@
             'Contract created by system\'],,'
             'SAM,"[(u\'Base Fee\', u\'800.6\', u\'USD\')]",'
-            'created,{\'en\': u\'Hello world\'},Our Sample Product,A111111\r\n',
+            'created,{\'en\': u\'Hello world\'},,A111111\r\n',
             result
             )
@@ -298,5 +298,5 @@
             'Contract created by system\'],,'
             'SAM,"[(u\'Base Fee\', u\'800.6\', u\'USD\')]",'
-            'created,{\'en\': u\'Hello world\'},Our Sample Product,A111111\r\n',
+            'created,{\'en\': u\'Hello world\'},,A111111\r\n',
             result
             )
@@ -318,7 +318,7 @@
             'Contract created by system\'],,'
             'SAM,"[(u\'Base Fee\', u\'800.6\', u\'USD\')]",'
-            'created,{\'en\': u\'Hello world\'},Our Sample Product,A111111\r\n',
-            result
-            )
-        return
-
+            'created,{\'en\': u\'Hello world\'},,A111111\r\n',
+            result
+            )
+        return
+